// T15modBin.sce
// ESTIMATION OF BINOMIAL/BERNOULLI MODEL 
// Experiments
// - change parameters of the model
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), mode(0)

p=.8; N=10;                             // params of binomial distribution
nd=1000;                                // dimensions of generated matrix

for t=1:nd
  x(t)=sampBin(p,N);                    // generation
end  

S=80; ka=10;                            // prior information
for t=1:nd
  S=S+x(t);
  ka=ka+1;
  pE(t)=S/(N*ka);
end

// Results
plot(pE)  
plot([nd/2 nd],[p p],':r')
xlabel('time','fontsize',4,'fontname','times')
ylabel('estimates','fontsize',4,'fontname','times')
title('Time evolution of the estimated parameter','fontsize',5,'fontname','times')
legend('estimats','true value');

// Remark
// For Bernoulli distribution set N = 1.
