// T16modPoi.sce
// SIMULATION AND ESTIMATION OF POISSON MODEL 
// Experiments
// - change parameter of the model laS
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), mode(0)

nd=500;                                                                 // 1
// SIMULATION                                                           // 2
laS=4;                                  // parameter                    // 3
y= grand(nd,1,"poi",1/laS)              // simulation                   // 4
                                                                        // 5
S=0; ka=0;                              // initial statistics           // 6
// ESTIMATION                                                           // 7
for t=1:nd                                                              // 8
  S=S+y(t);                             // update of statistics         // 9
  ka=ka+1;                                                              // 10
  laM(t)=ka/S;                          // point estimate of laS        // 11
end                                                                     // 12
                                                                        // 13
// RESULTS                                                              // 14
plot(laM)                                                               // 15
title 'Evolution of point estimates of the parameter'                   // 16
