// T41mixBasic.sce
// MIXTURE ESTIMATION (basic experiment)
// - static normal componens
// - scalar variables
// Experiments
// - change simulated expectations thS
// - change initial expectations thE (through the statistics S, ka)
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), 
getd(), mode(0)

nd=100;                                                                 // 1
// SIMULATION                                                           // 2
thS=[1 6 10];                      // simulated expectations            // 3
for t=1:nd                                                              // 4
  c(t)=ceil(3*randu());            // pointer                           // 5
  y(t)=thS(c(t))+randn();          // output                            // 6
end                                                                     // 7
// ESTIMATION                                                           // 8
// initialization                                                       // 9
S=[5 10 15];                       // initial sum statistics            // 10
ka=[1 1 1];                        // initial counter                   // 11
thE=S./ka;                         //initial point estimates            // 12
nc=length(S);                                                           // 13
// time loop                                                            // 14
for t=1:nd                                                              // 15
  for j=1:nc                                                            // 16
    q(j)=GaussN(y(t),thE(j),1);    // proximity                         // 17
  end                                                                   // 18
  w=q/sum(q);                      // weights                           // 19
  for j=1:nc                                                            // 20
    S(j)=S(j)+w(j)*y(t);           // update of sum statistics          // 21
    ka(j)=ka(j)+w(j);              // update of counter                 // 22
    thE(j)=S(j)/ka(j);             // point estimates                   // 23
  end                                                                   // 24
  tht(:,t)=thE';                   // remember for plot                 // 25
end                                                                     // 26
                                                                        // 27
// RESULTS                                                              // 28
set(scf(),'position',[800 100 600 400])                                 // 29
plot(tht')                                                              // 30
title 'Evolution of estimated parametrs'                                // 31
disp 'Simulated parameter values'                                       // 32
disp(thS)                                                               // 33
disp 'Final estimated parameters'                                       // 34
disp(thE)
