// ini1Region.sce
// Determination of component centers
// ------------------------------------------
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data

nd=100;                                 // number of data
for t=1:nd
  y(:,t)=[5;3;8]+[2;1;3].*rand(3,1,'n'); // data simulation
end

mi=min(y,'c');                          // minimum
ma=max(y,'c');                          // maximum

nc=5;                                   // number of components
for i=1:nc
  thI(:,i)=(mi+ma)/2+.2*(ma-mi).*rand(3,1,'n'); 
                                        // centers of components
end

scf();
plot(y(1,:),y(2,:),'b.')
plot(thI(1,:),thI(2,:),'ro','markersize',12)
xlabel x1
ylabel x2
title 'Centers for the first two variables'
