﻿// ini2IniPar.sce
// Initial parameter estimates and associated statistics
// -----------------------------------------------------
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
getd functions
rand('seed',0)

nd=500;             // number of data
I_estCov=0;         // estimation of noise covariances = 0|1 no|yes

// regression coefficients for simulation
Cy(1).th=[1 2 4]';
Cy(2).th=[5 3 2]';
Cy(3).th=[2 5 6]';
Cy(4).th=[3 8 8]';
nc=length(Cy);
// noise covariances for simulation
for i=1:4
  rn=.3*randn(3,3);
  Cy(i).cv=.1*(eye(3,3)+rn+rn');
end
// pointer parameters for simulation
Cp.th=fnorm(randu(1,3)+.1,2);

ct(1)=1;                                // initial poiner
for t=1:nd
  ct(1,t)=sum(cumsum(Cp.th)<randu())+1; // pointer generation
  j=ct(t);                              // active component
  y=Cy(j).th+uut(Cy(j).cv)*randn(3,1);  // output generation
  yt(:,t)=y;                            // remember output
end   

// 2d (marginal) clusters
set(scf(),'position',[600 100 800 600])
for i=1:2
  for j=i+1:3
    subplot(3,3,3*(i-1)+j)
    plot(yt(i,:),yt(j,:),'.','markersize',3)
    title('Var '+string(i)+' '+string(j))
  end
end
