// ini4aCov.sce
// Fixed covariance 
// ------------------------------------------
clc, clear,close(winsid()); mode(0)
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
getd c:\functions

nd=500;             // number of data
I_estCov=0;         // estimation of noise covariances ? 0|1 no|yes

// simulated reg.coef.
Sim.Cy(1).th=[0.9 -.5]';
Sim.Cy(2).th=[0.4 0.6]';
nc=length(Sim.Cy);
Sim.nc=nc;
// simulated noise covariances
Sim.Cy(1).sd=0.5*[1 -.6;-.6,1];
Sim.Cy(2).sd=0.3*[1 .2;.2,1];
// simulated pointer parameters
Sim.Cp.th=fnorm(ones(1,2)+.1,2);

Sim.ct(1)=1;                                      // initial poiner
// SIMULATION ==========================================================
for t=2:nd
  Sim.ct(1,t)=sum(randu(1,1)>cumsum(Sim.Cp.th))+1; // pointer gen.
  j=Sim.ct(t); // active component
  y=Sim.Cy(j).th+Sim.Cy(j).sd*randn(2,1);         // output gen.
  Sim.yt(:,t)=y;
end   

// initial parameters
a=.5;                         // std of scattering initial parametrs
for j=1:nc                    //  from those used in simulation
  [mr,mc]=size(Sim.Cy(1).th);
  Ps=[Sim.Cy(j).th;1]+[a*randn(mr,mc);0];    // initial parameters
  Est.Cy(j).V=Ps*Ps';                        // statistics
  Est.Cy(j).th=Sim.Cy(j).th+a*randn(2,1);    // pt.est. of reg.coef
  Est.Cy(j).sd=.01*eye(2,2);                 // standard deviation
end
Est.ka=ones(1,nc);            // counter
Est.Cp.V=ones(1,nc);          // pointer statistics
Est.Cp.th=fnorm(ones(1,nc));  // pointer parameter
w=fnorm(ones(1,nc));          // weights


// ESTIMATION ==========================================================
printf(' ')
for t=2:nd  
  if t/fix(nd/10)==fix(t/fix(nd/10)), printf('.'); end
  for j=1:nc
    [xxx,G(j)]=GaussN(Sim.yt(:,t),Est.Cy(j).th,Est.Cy(j).sd); 
                                             // proximity
  end
  Lq=G-max(G);
  q=exp(Lq);

  ww=q'.*Est.Cp.th; w=ww/sum(ww);            // generation of weights
  wt(:,t)=w';

  // Update of statistic 
  Ps=[Sim.yt(:,t)' 1];                       // extended reg.vec.
  for i=1:nc
    Est.Cy(i).V=Est.Cy(i).V+w(i)*Ps'*Ps;     // information matrix
    Est.ka(i)=Est.ka(i)+w(i);                // counter
    Est.Cp.V(i)=Est.Cp.V(i)+w(i);            // pointer statistics

    //nove rozdeleni informacni matice V
    Vy=Est.Cy(i).V(1:2,1:2);                 // part Vy  - y.y
    Vyp=Est.Cy(i).V($,1:2);                  // part Vyp - psi.y
    Vp=Est.Cy(i).V($,$);                     // part Vp  - psi.psi'
    Est.Cy(i).th=inv(Vp+1e-8*eye(Vp))*Vyp;   // pt.est. - reg.coef.
    Est.Cy(i).tht(:,t)=Est.Cy(i).th';        // pt.est. - covar.
    if I_estCov~=0
      // PT.EST. OF NOISE COVARIANCE - USED OR NOT
      Est.Cy(i).cv=(Vy-Vyp'*inv(Vp+1e-8*eye(Vp))*Vyp)/Est.ka(i); 
    end
  end
  Est.Cp.th=fnorm(Est.Cp.V,2);     // pt.est. of pointer parameter
  [ss,Est.ct(1,t)]=max(w);         // store
end

s=2:nd;
[q,T]=c2c(Sim.ct(s),Est.ct(s));
Ect=q(Est.ct(s));

S=list();                          // simulated clusters
for i=1:nc
  j=find(Sim.ct==i);
  S(i)=Sim.yt(:,j);
end  

C=list();                          // estimated clusters
for i=1:nc
  j=find(Ect==i);
  C(i)=Sim.yt(:,j);
end  

// Results
ACC=acc(Sim.ct(s),Ect');
//printf('\n Wrong classifications %d from %d\n',wr,length(s))

set(scf(1),'position',[300 100 1200 600])
subplot(121)
plot(Est.Cy(1).tht(1,:),Est.Cy(1).tht(2,:),'.')
plot(Est.Cy(1).tht(1,2),Est.Cy(1).tht(2,2),'g.','markersize',18)
plot(Sim.Cy(1).th(1),Sim.Cy(1).th(2),'ro','markersize',12)
subplot(122)
plot(Est.Cy(2).tht(1,:),Est.Cy(2).tht(2,:),'.')
plot(Est.Cy(2).tht(1,2),Est.Cy(2).tht(2,2),'g.','markersize',18)
plot(Sim.Cy(2).th(1),Sim.Cy(2).th(2),'ro','markersize',12)

set(scf(2),'position',[350 150 1200 600])
subplot(121)
plot(S(1)(1,:),S(1)(2,:),'b.')
plot(S(2)(1,:),S(2)(2,:),'r.')
title 'Simulated'
subplot(122)
plot(C(1)(1,:),C(1)(2,:),'b.')
plot(C(2)(1,:),C(2)(2,:),'r.')
title 'Estimated'








 
