﻿// ini8bPreClass.sce
// Inicializace s učitelem (jednoduchá varianta)
// ------------------------------------------
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
exec("ScIntro.sce",-1),mode(0)          // intro to sesion
rand('seed',0)

nd=500;             // number of data
ni=20;              // lenght of initialization phase
t_estCov=1;         // when estimation of covariances is switched on

// simulated reg.coef.
Sim.Cy(1).th=[1.9 -.5]';
Sim.Cy(2).th=[0.4 0.6]';
Sim.Cy(3).th=[-1.2 1.6]';
Sim.Cy(4).th=[.1 -1.6]';
Sim.Cy(5).th=[2.1 2.2]';
nc=length(Sim.Cy);
Sim.nc=nc;
// simulated noise covariances
rcv=.8;                       // amplitude of covariances
for i=1:nc
  g=rand(2,2,'u');
  Sim.Cy(i).cv=rcv*(eye(2,2)+(g+g'));
end
// simulated pointer parameters
Sim.Cp.th=fnorm(ones(1,nc)+.1,2);
Sim.ct(1)=1;                  // initial poiner

// SIMULATION ==========================================================
for t=1:nd
  Sim.ct(1,t)=sum(rand(1,1,'u')>cumsum(Sim.Cp.th))+1;    // pointer
  j=Sim.ct(t); // active component
  Sim.yt(:,t)=Sim.Cy(j).th+uut(Sim.Cy(j).cv)*rand(2,1,'norm'); // output
end   

// INITIALIZATION ======================================================
// initial parameters
for i=1:nc                    //  from those used in simulation
  Est.Cy(i).V=eye(3,3);
  Est.Cy(i).th=rand(2,1);            // pt.est. of reg.coef
  Est.Cy(i).cv=.1*eye(2,2);  // standard deviation
  Est.Cy(i).tht(:,1)=Est.Cy(i).th;
end
Est.ka=ones(1,nc);            // counter
Est.Cp.V=ones(1,nc);          // pointer statistics
Est.Cp.th=fnorm(ones(1,nc));  // pointer parameter
w=fnorm(ones(1,nc));          // weights

// ESTIMATION ==========================================================
I_estCov=0;
printf(' ')
for t=2:nd  
  if t/fix(nd/10)==fix(t/fix(nd/10)), printf('.'); end
  for j=1:nc
    [xxx,G(j)]=GaussN(Sim.yt(:,t),Est.Cy(j).th,Est.Cy(j).cv); 
                                             // proximity
  end
  Lq=G-max(G);
  q=exp(Lq);

  ww=q'.*Est.Cp.th; w=ww/sum(ww);            // generation of weights
  // KNOWN POINTERS FOR INITIAL DATA
  if t<=ni, w=zeros(1,nc); w(Sim.ct(t))=1; end
  wt(:,t)=w';

  // Update of statistic 
  Ps=[Sim.yt(:,t)' 1];                       // extended reg.vec.
  for i=1:nc
    Est.Cy(i).V=Est.Cy(i).V+w(i)*Ps'*Ps;     // information matrix
    Est.ka(i)=Est.ka(i)+w(i);                // counter
    Est.Cp.V(i)=Est.Cp.V(i)+w(i);            // pointer statistics

    //nove rozdeleni informacni matice V
    Vy=Est.Cy(i).V(1:2,1:2);                 // part Vy  - y.y
    Vyp=Est.Cy(i).V($,1:2);                  // part Vyp - psi.y
    Vp=Est.Cy(i).V($,$);                     // part Vp  - psi.psi'
    Est.Cy(i).th=inv(Vp+1e-8*eye(Vp))*Vyp;   // pt.est. - reg.coef.
    Est.Cy(i).tht(:,t)=Est.Cy(i).th';        // pt.est. - covar.
    if t>200, I_estCov=1; end
    if I_estCov~=0
      // PT.EST. OF NOISE COVARIANCE - USED OR NOT
      Est.Cy(i).cv=(Vy-Vyp'*inv(Vp+1e-8*eye(Vp))*Vyp)/Est.ka(i); 
    end
  end
  Est.Cp.th=fnorm(Est.Cp.V,2);     // pt.est. of pointer parameter
  [ss,Est.ct(1,t)]=max(w);         // store
end
disp ' '

// Results
bigfig(1)
for i=1:nc
//subplot(1,nc,i)
plot(Est.Cy(i).tht(1,:),Est.Cy(i).tht(2,:),'.')
plot(Est.Cy(i).tht(1,1),Est.Cy(i).tht(2,1),'g.','markersize',14)
plot(Sim.Cy(i).th(1),Est.Cy(i).th(2),'r.','markersize',8)
end
title 'zelené kolečko - kde to začlo, červená tečka - správná centra'

